CodeForces - 817D Imbalanced Array(单调栈)
Posted Frozen_Guardian
tags:
篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了CodeForces - 817D Imbalanced Array(单调栈)相关的知识,希望对你有一定的参考价值。
题目链接:点击查看
题目大意:给出一个长度为 n n n 的序列,求出所有子区间的最大值与最小值之差的和
题目分析:不难看出最大值和最小值之差的和可以拆开,拆成最大值之和与最小值之和之差,现在问题转换为如何求解所有子区间内的最值之和
可以单调栈维护每个数字的可行范围,这里以最小值为例,当我们遍历到 i i i 位置时,我们只需要求出左侧首次小于 a [ i ] a[i] a[i] 的位置 l l l,以及右侧首次小于 a [ i ] a[i] a[i] 的位置 r r r,那么 a [ i ] a[i] a[i] 的贡献就是:左端点属于区间 [ l , i ] [l,i] [l,i],同时右端点属于区间 [ i , r ] [i,r] [i,r] 的子区间了。
但是上述做法只适用于 n n n 个数字互不相同,如果遇到重复的数字会重复计算答案。
该怎么解决呢?其实仔细思考一下不难发现,可以令区间变成左闭右开或左开右闭,换句话说我们只需要让 l l l 变成左侧首个小于等于 a [ i ] a[i] a[i] 的位置或者让 r r r 变成右侧首个小于等于 a [ i ] a[i] a[i] 的位置就好了
具体证明可以口胡一下,对于一段连续数列 { 2 , 2 , 2 } \\{2,2,2\\} {2,2,2} 来说,如果 l l l 表示的是左侧首个小于 a [ i ] a[i] a[i] 的位置, r r r 表示的是右侧首个小于等于 a [ i ] a[i] a[i] 的位置,那么得到的三个开区间就是 ( 0 , 2 ) , ( 0 , 3 ) , ( 0 , 4 ) (0,2),(0,3),(0,4) (0,2),(0,3),(0,4),发现确实是覆盖了所有的区间
代码:
// Problem: J - Imbalanced Array
// Contest: Virtual Judge - 7.31限时训练(生成树,树的直径,单调栈)2
// URL: https://vjudge.net/contest/450440#problem/J
// Memory Limit: 262 MB
// Time Limit: 2000 ms
//
// Powered by CP Editor (https://cpeditor.org)
// #pragma GCC optimize(2)
// #pragma GCC optimize("Ofast","inline","-ffast-math")
// #pragma GCC target("avx,sse2,sse3,sse4,mmx")
#include<iostream>
#include<cstdio>
#include<string>
#include<ctime>
#include<cmath>
#include<cstring>
#include<algorithm>
#include<stack>
#include<climits>
#include<queue>
#include<map>
#include<set>
#include<sstream>
#include<cassert>
#include<bitset>
#include<list>
#include<unordered_map>
#define lowbit(x) (x&-x)
using namespace std;
typedef long long LL;
typedef unsigned long long ull;
template<typename T>
inline void read(T &x)
{
T f=1;x=0;
char ch=getchar();
while(0==isdigit(ch)){if(ch=='-')f=-1;ch=getchar();}
while(0!=isdigit(ch)) x=(x<<1)+(x<<3)+ch-'0',ch=getchar();
x*=f;
}
template<typename T>
inline void write(T x)
{
if(x<0){x=~(x-1);putchar('-');}
if(x>9)write(x/10);
putchar(x%10+'0');
}
const int inf=0x3f3f3f3f;
const int N=1e6+100;
int l[N],r[N];
LL a[N];
stack<int>st;
void init() {
while(st.size()) {
st.pop();
}
}
int main()
{
#ifndef ONLINE_JUDGE
// freopen("data.in.txt","r",stdin);
// freopen("data.out.txt","w",stdout);
#endif
// ios::sync_with_stdio(false);
int n;
LL ans=0;
read(n);
for(int i=1;i<=n;i++) {
read(a[i]);
}
init();
for(int i=1;i<=n;i++) {
while(st.size()&&a[st.top()]<=a[i]) st.pop();
if(st.empty()) l[i]=0;
else l[i]=st.top();
st.push(i);
}
init();
for(int i=n;i>=1;i--) {
while(st.size()&&a[st.top()]<a[i]) st.pop();
if(st.empty()) r[i]=n+1;
else r[i]=st.top();
st.push(i);
}
for(int i=1;i<=n;i++) {
ans+=a[i]*(r[i]-i)*(i-l[i]);
}
init();
for(int i=1;i<=n;i++) {
while(st.size()&&a[st.top()]>=a[i]) st.pop();
if(st.empty()) l[i]=0;
else l[i]=st.top();
st.push(i);
}
init();
for(int i=n;i>=1;i--) {
while(st.size()&&a[st.top()]>a[i]) st.pop();
if(st.empty()) r[i]=n+1;
else r[i]=st.top();
st.push(i);
}
for(int i=1;i<=n;i++) {
ans-=a[i]*(r[i]-i)*(i-l[i]);
}
cout<<ans<<endl;
return 0;
}
以上是关于CodeForces - 817D Imbalanced Array(单调栈)的主要内容,如果未能解决你的问题,请参考以下文章
代码源 Div1#103子串的最大差 Codeforces - 817D,力扣2104,1900分